︠66efdb08-37c2-45fe-ba55-b66dbe32d8a5i︠
%html
<h1><center>ELLIPTIC CURVE POLLARD RHO ATTACK </center></h1>
︡7e2ab8e0-cbd2-4c8b-acc1-fa2ac3bead8b︡{"done":true,"html":"<h1><center>ELLIPTIC CURVE POLLARD RHO ATTACK </center></h1>"}
︠f532005e-76db-4fd0-87c1-29f61ea908d4s︠

import numpy
import itertools
import math
############################################################################################################################
# For all these procedures we are working with elliptic curve (EC) groups over Z_p where p is a prime number larger than 3.#
# An Elliptic Curve group will be represented by a triple [A,B,p] where                                                    #
#      (1) p is a prime number larger than 3                                                                               #
#      (2) A is the coefficient of x and                                                                                   #
#      (3) B is the constant term in  y^2 = x^3 + A*x + B mod p.                                                           #
#                                                                                                                          #
# A point in the group will be represented as a pair [x,y] where                                                           #
#      (1)  x is the x-coordinate of a solution                                                                            #
#      (2)  y is the y-coordinate of a solution                                                                            #
#      (3)  The identity will be represented by []                                                                         #
############################################################################################################################


def TonSh (a, Prime):
    if kronecker(a, Prime) == -1:
        pass
        print ("{0} does not have a square root mod {1}".format(a, Prime))
        return None
    elif Prime % 4 == 3:
        x = power_mod(ZZ(a), ZZ((Prime+1)/4),ZZ(Prime))
        return(x)
    else:
        #################################################################################
        # Determine e so that Prime-1 = (2^e)*q for some odd number q                   #
        #################################################################################

        e = ZZ(0)
        q = ZZ(Prime - 1)
        for j in itertools.count(1):
            if q % 2 == 0:
                e = ZZ(e + 1)
                q = ZZ(q / 2)
            else:
                break
        for i in range(1, 101):
            n = i
            if kronecker(n, Prime) == -1:
                break
        z = power_mod(ZZ(n),ZZ(q),ZZ(Prime))
        y = ZZ(z)
        r = ZZ(e)
        x = power_mod(ZZ(a),ZZ( (q-1)/2),ZZ( Prime))
        b = (a * x ** 2) % Prime
        x = (a * x) % Prime
        for i in itertools.count(1):
            if b == 1:
                break
            else:
                for m in itertools.count(1):
                    t = power_mod(ZZ(b), ZZ(2^m) ,  ZZ(Prime))
                    if t == 1:
                        mm = m
                        break
                t = power_mod(ZZ(y), ZZ(2^(r - mm - 1)),ZZ(Prime))
                y = power_mod(ZZ(t), ZZ(2),ZZ(Prime))
                r = mm
                x = (x * t) % Prime
                b = (b * y) % Prime
        return(x)
︡c9abfefa-ac06-4535-9550-17a0b4edf184︡{"done":true}
︠fe9afb6c-cd41-45d0-abe7-658cdef84801i︠
%html
<strong>ECSearch</strong> is a procedure that searches for a point on a given elliptic curve with first coordinate between "lowerbound" and "upperbound". The lowerbound and the upperbound are positive random numbers.
︡22e60cd1-fc96-4707-9d43-3f31b704f851︡{"done":true,"html":"<strong>ECSearch</strong> is a procedure that searches for a point on a given elliptic curve with first coordinate between \"lowerbound\" and \"upperbound\". The lowerbound and the upperbound are positive random numbers."}
︠2161ecd3-c2c8-4544-b76a-81577847c3f6s︠
import itertools
def ECSearch (lowerbound, upperbound, Group):
    p = Group[2]
    a = Group[0]
    b = Group[1]
    if (4 * a ** 3 + 27 * b ** 2) % p == 0:
        print ("This is not an elliptic curve.")
    else:
        for j in itertools.count(lowerbound):
            if j==lowerbound-1 or j>upperbound or j>upperbound:
                return "not found"
            j=j%p
            if kronecker(j ** 3 + a * j + b, p) == 1:
                x = (j ** 3 + a * j + b) % p
                var('z')
                L=TonSh(x,p)
                y = L
                return([j,y])

import sympy.ntheory
def FermatGreat (N):
    if sympy.ntheory.isprime(N):
        if N % 4 == 1:
            Z = two_squares(N)
            #print(Z)
            return(Z)
        else:
            print ("{0} is prime, but {1} mod 4 = 3".format(N, N))
    else:
        print ("{0} is not prime\n".format(N))
︡2d4a1ff1-eb06-4027-8f70-9b592f7c5d5f︡{"done":true}
︠5a6c9c68-acc5-4b1f-a62a-38d75bbcbe78i︠

%html
<strong>ECAdd</strong> is a procedure that computes the sum of two points on a given elliptic curve using the elliptic curve operation.
︡0071d75d-d937-478e-8768-6adc3c87f3ec︡{"done":true,"html":"<strong>ECAdd</strong> is a procedure that computes the sum of two points on a given elliptic curve using the elliptic curve operation."}
︠e3b92bea-5010-4542-975b-3b7e37c539bbs︠
def ECAdd (Point1, Point2, Group):
    a = Group[0]
    b = Group[1]
    p = Group[2]
    if(Point1!=[]):
        x1 = Point1[0]
        y1 = Point1[1]
    if(Point2!=[]):
        x2 = Point2[0]
        y2 = Point2[1]
    if (4 * a ** 3 + 27 * b ** 2) % p == 0:
        print ("This is not an elliptic curve.")
    elif Point1 != [] and y1 ** 2 % p != (x1 ** 3 + a * x1 + b) % p:
        print ("Point 1 is not on the elliptic curve. \n")
    elif Point2 != [] and y2 ** 2 % p != (x2 ** 3 + a * x2 + b) % p:
        print ("Point 2 is not on the elliptic curve. \n")
    else:
        if Point1 == []:
            R = Point2
        elif Point2 == []:
            R = Point1
        else:
            if x1 == x2 and 0 == (y1 + y2) % p:
                R = []
            elif x1 == x2 and y1 == y2:
                R = ECDouble(Point1, Group)
            else:
                s = ((y1 - y2) / (x1 - x2)) % p
                x = (s ** 2 - x1 - x2) % p
                y = (s * (x1 - x) - y1) % p
                R = [x,y]
    return(R)
︡da917ff3-4392-4079-a110-f6d9107d7ec0︡{"done":true}
︠bc859890-ec73-426f-aff6-3f472e09f1afs︠
def ECDouble (Point, Group):
    a = Group[0]
    b = Group[1]
    p = Group[2]
    if Point != []:
        x1 = Point[0]
        y1 = Point[1]
        if (4 * a ** 3 + 27 * b ** 2) % p == 0:
            print ("This is not an elliptic curve.")
        elif Point != [] and y1 ** 2 % p != (x1 ** 3 + a * x1 + b) % p:
            print ("The point to double is not on the elliptic curve.")
        elif y1 == 0:
            R = []
        else:
            s = mod((3 * x1 ** 2 + a) / y1 / 2, p)
            x = (s ** 2 - 2 * x1) % p
            y = (s * (x1 - x) - y1) % p
            R = [x,y]
    else:
        R = []
    return(R)
︡d45470ff-f56e-48cf-9a59-0153f7e05a02︡{"done":true}
︠217d8d28-6275-4f8d-85e9-2a509122aa32s︠

def ECInverse (Point, Group):
    if Point == []:
        return(Point)
    else:
        p = Group[2]
        x = Point[0]
        y = Point[1]
        return([x,(p - y) % p])
︡efebece5-ad7e-4656-b517-b189a68539f8︡{"done":true}
︠87caeaaf-2b72-4e9d-8a34-a7c8483a83d2i︠
%html
<strong>ECTimes</strong> is a procedure that adds a point k-times (scalar) to itself for a given elliptic curve using the elliptic curve operation.
︡a59890b0-9569-42fa-b797-f3f40c0bb51d︡{"done":true,"html":"<strong>ECTimes</strong> is a procedure that adds a point k-times (scalar) to itself for a given elliptic curve using the elliptic curve operation."}
︠aee6fd9a-0432-491f-b9b7-ba936fb01bbas︠
def ECTimes (Point, scalar, Group):
    ECIdentity=[]
    if Point == ECIdentity or scalar == 0:
        return(ECIdentity)
    else:
        E=EllipticCurve(GF(Group[2]),[Group[0],Group[1]])
        EPoint = E(Point[0],Point[1])
        cgret = scalar*EPoint
        if(cgret[0]==0 and cgret[1]==1 and cgret[2]==0):
            return ECIdentity
        return([cgret[0],cgret[1]])


︡bfbe6a29-f738-4d4d-a042-575497637937︡{"done":true}
︠96c23f4c-afee-4362-a400-dadd25d64f52s︠

def GroupOrder(Group): ############ Computes order of an elliptic curve group
    E = EllipticCurve(GF(Group[2]),[Group[0],Group[1]])
    return E.order()


def findptOrder(point,group): ############# Computes the order of a point on the elliptic curve group
    E = EllipticCurve(GF(group[2]),[group[0],group[1]])
    Ep = E(point[0],point[1])
    return Ep.additive_order()



︡2caf5cd3-73ff-478e-bce8-ab4d11574b0f︡{"done":true}
︠68ac4951-2262-4b6f-ba0c-32e33c5100b2i︠
%html
<h1><center>ELLIPTIC CURVE Pollard's  Rho Algorithm </center></h1>
︡1c046c56-737c-49a2-9ed9-aaa1a3ab88bc︡{"done":true,"html":"<h1><center>ELLIPTIC CURVE Pollard's  Rho Algorithm </center></h1>"}
︠f5fada44-e4ba-4017-a743-1a7a6668115cs︠
def Rhof(point,P,Q,Group,j):
    if point!=[]:
        pointMod3 = ZZ(mod(point[0],3))
        if pointMod3 == 0:
            pt = ECAdd(point,P,Group)
        elif pointMod3 == 1:
            pt = ECDouble(point,Group)
        else:
            pt = ECAdd(point,Q,Group)
        return pt
    return None
︡510b959a-fda5-4978-8d54-1bba88674d9e︡{"done":true}
︠b3a9f98a-d8b2-4a9d-bb1a-3673b6586512s︠
def Rhofcoef(a,b,point,gorder):
    a1 = a
    b1 = b
    if point!=[]:
        pointMod3 = ZZ(mod(point[0],3))
        if pointMod3 == 0:
            a1 = ZZ(mod(a1+1,gorder))
        elif pointMod3 == 1:
            a1=(2*a1) % gorder
            b1=(2*b1) % gorder
        else:
            b1 = (b1+1) %gorder
        return [a1,b1]
︡993033f7-eef1-45b0-bacc-4ce88f00fe19︡{"done":true}
︠b7508189-b7be-4933-b018-fe5d0fb00e9es︠

def RhoOnEC(Q,P,Group,gorder):  #g --> P, y--> Q
    debug = False
    z=P
    t=P
    ab = [1,0]
    AB = [1,0]
    ############ This is Floyd's Cycle-Finding Method
    foundOne = False
    for j in itertools.count(1):
        if j>2425 and debug:
            print ("top of the loop {0}".format(j))
            print (ab)
            print (AB)
        ab = Rhofcoef(ab[0],ab[1],z,gorder)
        z = Rhof(z,P,Q,Group,j)
        if z==[]:
            d = gcd(ab[1],gorder)
            x = ZZ(mod(ab[0]/(-ab[1]), (gorder/d)))
            return x
        AB = Rhofcoef(AB[0],AB[1],t,gorder)
        t = Rhof(t,P,Q,Group,j)
        if t==[]:
            d = gcd(AB[1],gorder)
            x = ZZ(mod(AB[0]/(-AB[1]), (gorder/d)))
            return x
        AB = Rhofcoef(AB[0],AB[1],t,gorder)
        t = Rhof(t,P,Q,Group,j)
        if j==2458 and debug:
            print (t)
            print (z)
            print (z==t)
        if t==[]:
            d = gcd(AB[1],gorder)
            x = ZZ(mod(AB[0]/(-AB[1]) , (gorder/d)))
            return x
        elif z==t:
            d = gcd(AB[1]-ab[1],gorder)
            x =ZZ(mod((ab[0]-AB[0])/(AB[1]-ab[1]),(gorder/d)))
            return x

︡856179db-de4c-4ad3-a844-2999eff8ae5d︡{"done":true}
︠67635bd2-1c4c-445e-9122-8c3ead0acabai︠
%html
<strong>Example.</strong> The following example illustrates how elliptic curve private (encryption or signature) key can be recovered using the Pollard's Rho Attack. The public elliptic (encryption or signature) key is given by an elliptic curve group $G$, and two points $P$, $Q$ on the elliptic curve. It is known that $Q$ is a multiple of $P$ i.e. $Q=xP$. Note that this attack can be applied to elliptic curve encryption and elliptic curve signature.
︡2e919c78-2c77-4889-a0b9-7c3bdcad92c3︡{"done":true,"html":"<strong>Example.</strong> The following example illustrates how elliptic curve private (encryption or signature) key can be recovered using the Pollard's Rho Attack. The public elliptic (encryption or signature) key is given by an elliptic curve group $G$, and two points $P$, $Q$ on the elliptic curve. It is known that $Q$ is a multiple of $P$ i.e. $Q=xP$. Note that this attack can be applied to elliptic curve encryption and elliptic curve signature."}
︠fb706e18-e546-490c-9a74-796c6f58d07co︠
︡4bd8d55d-56e5-4f49-bc43-13d1e8295090︡
︠f01ffca8-129c-4a6b-a912-ee198d95a2a3s︠
p1 = next_prime(13276123213123)
A1 = 0
B1= 328
G1=[A1,B1,p1] ######################### Elliptic Curve Group
P1=[228287229281, 9234149811619]
Q1=[3412728539209, 5129210006826]
gord1 = findptOrder(P1,G1) ########### gord is the order of the point P in the elliptic curve group G


︡fa09bdca-6094-4754-a7f1-637f0a730c7c︡{"done":true}
︠0b2f72b7-40ab-4b87-90ba-e80b01f0d726s︠

x = RhoOnEC(Q1,P1,G1,gord1)
print("The Discrete Log is x=",x)
︡c75f847b-d75a-4f92-908f-fd1a4f6ec44a︡{"stdout":"The Discrete Log is x= 1266778\n"}︡{"done":true}
︠0c1e280a-93e2-4181-8171-6b21cc000637s︠
QQ1= ECTimes(P1,x,G1) ######## test the solution
Q1==QQ1
︡03a1ae4f-857a-4869-86b1-f7ba47137627︡{"stdout":"True\n"}︡{"done":true}









